-- Bug:	   With doesn't work with local definitions.
-- Status: Fixed. Bound variables weren't taken into consideration when
--	   creating the call to the auxiliary function.

data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

data Bool : Set where
  false, true : Bool

even : Nat -> Bool
even 0		   = true
even 1		   = false
even (suc (suc n)) = even n

T : Nat -> Set
t : (n:Nat) -> T n
(==) (a:Set) : a -> a -> Prop

f : Nat -> Nat
f 0	  = 0
f (suc n) = g
  where
    g : Nat
    g with even n =>
      true  = zero
      false = suc n

bug : t 0 == t (f 5)

